#Include "crt/stdlib.bi"         ' Required for: malloc(), free()
#Define GL_GLEXT_PROTOTYPES
#Include Once "gl/glext.bi"
#Include Once "gl/glu.bi"
#Ifndef DEFAULT_MESH_VERTEX_BUFFERS
#define DEFAULT_MESH_VERTEX_BUFFERS    7    ' Number of vertex buffers (VBO) per mesh0
#endif
#Include Once "fbgfx.bi"
'Sub rlLoadMesh(mesh0 As Mesh ptr,dynamic0 As boolean)
'' define OpenGL proc
'#define glDef(n) dim As PFN##n##PROC n
'' get OpenGL proc (abort if something goes wrong)
'#define glProc0(n) n = *(@( n)):Print #n,n' : if n = 0 then screen 0 : ? "error: " & #n : sleep: end 
'' VBO
'glDef(glBindBuffer)
'glDef(glDeleteBuffers)
'glDef(glGenBuffers)
'glDef(glIsBuffer)
'glDef(glBufferData)
'glDef(glBufferSubData)
'glDef(glGetBufferSubData)
'glDef(glMapBuffer)
'glDef(glUnmapBuffer)
'glDef(glGetBufferParameteriv)
'glDef(glGetBufferPointerv)
'glDef(glDrawBuffers)
'glDef(glGenVertexArrays)
'glDef(glBindVertexArray)
'glDef(glVertexAttribPointer)
'glDef(glEnableVertexAttribArray)
'glDef(glVertexAttrib3f)
'glDef(glDisableVertexAttribArray)
'glDef(glVertexAttrib4f)
'glDef(glVertexAttrib2f)
'
'
'' Shader
'glDef(glCreateProgram)
'glDef(glDeleteProgram)
'glDef(glCreateShader)
'glDef(glDeleteShader)
'glDef(glCompileShader)
'glDef(glIsProgram)
'glDef(glIsShader)
'glDef(glShaderSource)
'glDef(glGetShaderInfoLog)
'glDef(glGetShaderiv)
'glDef(glAttachShader)
'glDef(glDetachShader)
'glDef(glLinkProgram)
'glDef(glUseProgram)
'' VBO
'  glProc0(glBindBuffer)
'  glProc0(glDeleteBuffers)
'  glProc0(glGenBuffers)
'  glProc0(glIsBuffer)
'  glProc0(glBufferData)
'  glProc0(glBufferSubData)
'  glProc0(glGetBufferSubData)
'  glProc0(glMapBuffer)
'  glProc0(glUnmapBuffer)
'  glProc0(glGetBufferParameteriv)
'  glProc0(glGetBufferPointerv)
'  glProc0(glDrawBuffers)
'  glProc0(glGenVertexArrays)
'glProc0(glBindVertexArray)
'glProc0(glVertexAttribPointer)
'glProc0(glEnableVertexAttribArray)
'glProc0(glVertexAttrib3f)
'glProc0(glDisableVertexAttribArray)
'glProc0(glVertexAttrib4f)
'glProc0(glVertexAttrib2f)
'  ' shader
'  glProc0(glCreateProgram)
'  glProc0(glDeleteProgram)
'  glProc0(glCreateShader)
'  glProc0(glDeleteShader)
'  glProc0(glCompileShader)
'  glProc0(glIsProgram)
'  glProc0(glIsShader)
'  glProc0(glShaderSource)
'  glProc0(glGetShaderInfoLog)
'  glProc0(glGetShaderiv)
'  glProc0(glAttachShader)
'  glProc0(glDetachShader)
'  glProc0(glLinkProgram)
'  glProc0(glUseProgram)
'
'    if (mesh0->vaoId > 0) Then
'        ' Check if mesh0 has already been loaded in GPU
'        TRACELOG(LOG_WARNING, "VAO: [ID %i] Trying to re-load an already loaded mesh0", mesh0->vaoId)
'        Exit Sub
'    EndIf
'
'    mesh0->vaoId = 0        ' Vertex Array Object
'    mesh0->vboId[0] = 0     ' Vertex positions VBO
'    mesh0->vboId[1] = 0     ' Vertex texcoords VBO
'    mesh0->vboId[2] = 0     ' Vertex normals VBO
'    mesh0->vboId[3] = 0     ' Vertex colors VBO
'    mesh0->vboId[4] = 0     ' Vertex tangents VBO
'    mesh0->vboId[5] = 0     ' Vertex texcoords2 VBO
'    mesh0->vboId[6] = 0     ' Vertex indices VBO
'
'#If defined(GRAPHICS_API_OPENGL_33) Or defined(GRAPHICS_API_OPENGL_ES2)
'    Dim As Integer drawHint = GL_STATIC_DRAW
'    if (dynamic0) Then drawHint = GL_DYNAMIC_DRAW
'
'    'if (RLGL.ExtSupported.vao) Then
'    '    ' Initialize Quads VAO (Buffer A)
'       	glGenVertexArrays(1, @mesh0->vaoId)
'	      glBindVertexArray(mesh0->vaoId)
'    'EndIf
'    ' NOTE: Attributes must be uploaded considering default locations points
'    ' Enable vertex attributes: position (shader-location = 0)
'    
'    glGenBuffers(1, @mesh0->vboId[0])
'    glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[0])
'    glBufferData(GL_ARRAY_BUFFER, mesh0->vertexCount*3*sizeof(Single), mesh0->vertices, drawHint)
'    glVertexAttribPointer(0, 3, GL_FLOAT, 0, 0, 0)
'    glEnableVertexAttribArray(0)
'
'    ' Enable vertex attributes: texcoords (shader-location = 1)
'    glGenBuffers(1, @mesh0->vboId[1])
'    glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[1])
'    glBufferData(GL_ARRAY_BUFFER, mesh0->vertexCount*2*sizeof(Single), mesh0->texcoords, drawHint)
'    glVertexAttribPointer(1, 2, GL_FLOAT, 0, 0, 0)
'    glEnableVertexAttribArray(1)
'
'    ' Enable vertex attributes: normals (shader-location = 2)
'    if (mesh0->normals <> NULL) Then
'        glGenBuffers(1, @mesh0->vboId[2])
'        glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[2])
'        glBufferData(GL_ARRAY_BUFFER, mesh0->vertexCount*3*sizeof(Single), mesh0->normals, drawHint)
'        glVertexAttribPointer(2, 3, GL_FLOAT, 0, 0, 0)
'        glEnableVertexAttribArray(2)
'    Else
'        ' Default color vertex attribute set to WHITE
'        glVertexAttrib3f(2, 1.0f, 1.0f, 1.0f)
'        glDisableVertexAttribArray(2)
'    endif
'
'    ' Default color vertex attribute (shader-location = 3)
'    if (mesh0->colors <> NULL) then
'        glGenBuffers(1, @mesh0->vboId[3])
'        glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[3])
'        glBufferData(GL_ARRAY_BUFFER, mesh0->vertexCount*4*sizeof(ubyte), mesh0->colors, drawHint)
'        glVertexAttribPointer(3, 4, GL_UNSIGNED_BYTE, GL_TRUE, 0, 0)
'        glEnableVertexAttribArray(3)
'    Else
'        ' Default color vertex attribute set to WHITE
'        glVertexAttrib4f(3, 1.0f, 1.0f, 1.0f, 1.0f)
'        glDisableVertexAttribArray(3)
'    EndIf
'
'    ' Default tangent vertex attribute (shader-location = 4)
'    if (mesh0->tangents <> NULL) then
'        glGenBuffers(1, @mesh0->vboId[4])
'        glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[4])
'        glBufferData(GL_ARRAY_BUFFER, mesh0->vertexCount*4*sizeof(Single), mesh0->tangents, drawHint)
'        glVertexAttribPointer(4, 4, GL_FLOAT, 0, 0, 0)
'        glEnableVertexAttribArray(4)
'    Else
'        ' Default tangents vertex attribute
'        glVertexAttrib4f(4, 0.0f, 0.0f, 0.0f, 0.0f)
'        glDisableVertexAttribArray(4)
'    EndIf
'
'    ' Default texcoord2 vertex attribute (shader-location = 5)
'    if (mesh0->texcoords2 <> NULL) Then
'        glGenBuffers(1, @mesh0->vboId[5])
'        glBindBuffer(GL_ARRAY_BUFFER, mesh0->vboId[5])
'        glBufferData(GL_ARRAY_BUFFER, (mesh0->vertexCount)*2*sizeof(single), mesh0->texcoords2, drawHint)
'        glVertexAttribPointer(5, 2, GL_FLOAT, 0, 0, 0)
'        glEnableVertexAttribArray(5)
'    Else
'        ' Default texcoord2 vertex attribute
'        glVertexAttrib2f(5, 0.0f, 0.0f)
'        glDisableVertexAttribArray(5)
'    EndIf
'
'    if (mesh0->indices <> NULL) then
'        glGenBuffers(1, @mesh0->vboId[6])
'        glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, mesh0->vboId[6])
'        glBufferData(GL_ELEMENT_ARRAY_BUFFER, (mesh0->triangleCount)*3*sizeof(ushort), @mesh0->indices[0], drawHint)
'    EndIf
'
''    if (RLGL.ExtSupported.vao) Then
'        if (mesh0->vaoId > 0) Then
'        	TRACELOG(LOG_INFO, "VAO: [ID %i] Mesh uploaded successfully to VRAM (GPU)", mesh0->vaoId)
'        else 
'     	  TRACELOG(LOG_WARNING, "VAO: Failed to load mesh0 to VRAM (GPU)")
'        EndIf
'    'Else
'    '    TRACELOG(LOG_INFO, "VBO: Mesh uploaded successfully to VRAM (GPU)")
'    'EndIf
'#EndIf
'End Sub
'
'Sub AllocateMeshData(mesh0 As Mesh Ptr, verts As integer, triangles As integer, colors As integer, uvs As boolean, uv2s As boolean)
'	mesh0->vboId = Cast(uinteger ptr,MAlloc((DEFAULT_MESH_VERTEX_BUFFERS) *sizeof(UInteger)))
'	for i As integer = 0 to DEFAULT_MESH_VERTEX_BUFFERS -1
'		mesh0->vboId[i] = 0
'	Next
'	mesh0->vertices = Cast(Single ptr,MAlloc(verts * 3 * sizeof(Single)))
'	mesh0->normals = Cast(Single Ptr,MAlloc(verts * 3 * sizeof(single)))
'
'	if (uvs) Then
'		mesh0->texcoords = Cast(Single Ptr,MAlloc(verts * 2 * sizeof(Single)))
'	else
'		mesh0->texcoords = NULL
'	EndIf
'	if (uv2s) Then
'		mesh0->texcoords2 = Cast(Single Ptr,MAlloc(verts * 2 * sizeof(single)))
'	else
'		mesh0->texcoords2 = NULL
'	EndIf
'	mesh0->indices = Cast(ushort Ptr,MAlloc(triangles * 3 * sizeof(ushort)))
'	mesh0->vertexCount = verts
'	mesh0->triangleCount = triangles
'	TRACELOG(LOG_INFO, "MeshData Alocated!")
'	rlLoadMesh(mesh0,FALSE)
'End sub
''
''Function GenMeshCustom(generate As MeshGenerateCallback , userData As Any Ptr) As Mesh
''
''	Dim mesh0 As Mesh
''
''	if (generate <> NULL)   Then' ask the callback to generate the mesh0 data
''		generate(@mesh0, userData)
''	EndIf
''	' Upload vertex data to GPU (static mesh0)
''	'rlLoadMesh(@mesh0, false)
''
''	return mesh0
''End Function
''
'
'
'
'Function build_cube(posi As Vector3) As Mesh
'
'
'
'	Dim mesh0 As Mesh'=GenMeshCube(1,1,1)
'	Dim As Vector3 Vertices(0 To ...) = {_
'	Vector3 (-0.5+posi.x, -0.5+posi.y,  0.5+posi.z),_
'	Vector3 ( 0.5+posi.x, -0.5+posi.y,  0.5+posi.z),_
'	Vector3 ( 0.5+posi.x,  0.5+posi.y,  0.5+posi.z),_
'	Vector3 (-0.5+posi.x,  0.5+posi.y,  0.5+posi.z),_
'	Vector3 (-0.5+posi.x, -0.5+posi.y, -0.5+posi.z),_
'	Vector3 (-0.5+posi.x,  0.5+posi.y, -0.5+posi.z),_
'	Vector3 ( 0.5+posi.x,  0.5+posi.y, -0.5+posi.z),_
'	Vector3 ( 0.5+posi.x, -0.5+posi.y, -0.5+posi.z)_
'	}
'
'	dim As Vector3 triangles(0 To ...) = { _
'	_'face front
'	Vector3 (0, 1, 2),_
'	Vector3 (1, 2, 0),_
'	_'face top
'	Vector3 (2, 0, 2),_
'	Vector3 (0, 2, 3),_
'	_'face Right
'	Vector3 (2, 3, 4),_
'	Vector3 (3, 4, 5),_
'	_'face Left
'	Vector3 (4, 5, 6),_
'	Vector3 (5, 6, 4),_
'	_'face back
'	Vector3 (6, 4, 6),_
'	Vector3 (4, 6, 7),_
'	_'face bottom
'	Vector3 (6, 7, 8),_
'	Vector3 (7, 8, 9)_
'	}
'	
'
'
'	'Dim mesh0 As Mesh 'Ptr=calloc(1,SizeOf(Mesh))
'		'Print mesh0.vertexCount
'		'Print mesh0.triangleCount
'		'For i As UInteger=0 To mesh0.vertexCount-1 Step 3
'		'	Print mesh0.vertices[i+0];" ";mesh0.vertices[i+1];" ";mesh0.vertices[i+2]
'
'		'Next
'		'Print UBound(vertices)
'		'For i As UInteger=0 To UBound(vertices)
'		'Print vertices(i).x;" ";vertices(i).y;" ";vertices(i).z
'		'Next
'		'For i As UInteger=0 To mesh0.triangleCount-1 Step 1
'		'	Print mesh0.indices[i+0];" ";mesh0.indices[i+1];" ";mesh0.indices[i+2]
'
'		'Next
'
'		'For i As UInteger=0 To UBound(triangles) Step 1
'		'Print triangles(i).x;" ";triangles(i).y;" ";triangles(i).z
'
'		'Next
'		
'		'vertices
'		'texcoords
'		'texcoords2
'		'normals
'		'tangents
'		'colors
'		'indices
'		'animVertices
'		'animNormals
'		'boneIds
'		'boneWeights
'		'Print mesh0.vaoId
'		'Print mesh0.vboId
'
'	
'	AllocateMeshData(@mesh0, (UBound(Vertices)+1), (UBound(triangles)+1)\3, 0, FALSE, false)
'	memcpy(mesh0.vertices, @Vertices(0),  (UBound(Vertices)+1) * 3 * sizeof(Single))
'	'memcpy(mesh0.normals, @Vertices(0), (UBound(triangles) )* 3 * sizeof(Single))
'	For i As Integer=0 To (UBound(triangles))\3 'mesh0.triangleCount-1 Step 1
'		mesh0.indices[0+i*3] = triangles(i).x
'		mesh0.indices[1+i*3] = triangles(i).y
'		mesh0.indices[2+i*3] = triangles(i).z
'	Next
''glBufferData(GL_ELEMENT_ARRAY_BUFFER, mesh0.triangleCount*3*sizeof(ushort), mesh0.indices, GL_STATIC_DRAW)
'
''rlLoadMesh(@mesh0, false)
'	Return mesh0
'End Function
'Sub BuildMesh(mesh0 As Mesh ptr, vertices As Vector3 Ptr,nrVecs As integer,indicies As Vector3 Ptr,nrInd As integer)
'
'    Dim As Vector3 minOrigin = Vector3( 0, 0, 0 )
'    Dim As Vector3 maxOrigin = Vector3( 1.0f, 1.0f, .0f )
'
'    Dim As Single minV = 0
'
'    Dim As single vertices(...) = { _
'        minOrigin.x,maxOrigin.y,maxOrigin.z, _
'        minOrigin.x,minOrigin.y,maxOrigin.z, _
'        maxOrigin.x,maxOrigin.y,maxOrigin.z, _
'        maxOrigin.x,minOrigin.y,maxOrigin.z _
'    }
'
'    Dim As single texcoords(...) = { _
'        1,minV,_
'        1,1,_
'        0,minV,_
'        0,1 _
'    }
'
'    Dim As single normals(...) = { _
'        0.0f, 0.0f, -1.0f,_
'        0.0f, 0.0f, -1.0f,_
'        0.0f, 0.0f, -1.0f,_
'        0.0f, 0.0f, -1.0f _
'    }
'
'    AllocateMeshData(mesh0, 4, 2, 0, true, false)
'    memcpy(mesh0->vertices, @vertices(0), 4 * 3 * sizeof(Single))
'    memcpy(mesh0->texcoords, @texcoords(0), 4 * 2 * sizeof(Single))
'    memcpy(mesh0->normals, @normals(0), 4 * 3 * sizeof(Single))
'
'    mesh0->indices[0] = 2
'    mesh0->indices[1] = 1
'    mesh0->indices[2] = 0
'
'    mesh0->indices[3] = 2
'    mesh0->indices[4] = 3
'    mesh0->indices[5] = 1
'
'    mesh0->vertexCount = 4
'    mesh0->triangleCount = 2
'End Sub


'void DebugDrawNormals(Model *model)
'{
'    for (int m = 0; m < (*model).meshCount; m++)
'    {
'        if ( (*model).meshes[m].normals != NULL)
'        {
'            for (int i = 0, v = 0; i < (*model).meshes[m].vertexCount; i++, v += 3)
'            {
'                Vector3 vertex;
'                Vector3 normal;
'                
'                vertex.x = (*model).meshes[m].vertices[v];
'                vertex.y = (*model).meshes[m].vertices[v + 1];
'                vertex.z = (*model).meshes[m].vertices[v + 2];
'                
'                normal.x = (*model).meshes[m].normals[v];
'                normal.y = (*model).meshes[m].normals[v + 1];
'                normal.z = (*model).meshes[m].normals[v + 2];
'                
'                vertex = Vector3Transform(vertex, (*model).transform);
'                normal = Vector3Transform(normal, (*model).transform);
'                
'                Vector3 offset = Vector3Scale( normal, 1.0f );
'                offset = Vector3Add( vertex, offset );
'                DrawLine3D(vertex, offset, GREEN);
'            }
'        }
'    }
'}