#include "fbgfx.bi"
RANDOMIZE Timer

ScreenRes 800,600,32
Type n_t
	n As UByte
	state(0 To 255) As ubyte
	Declare Sub shufle()
	Declare Sub update()
	Declare Sub prints()
End Type
Sub n_t.shufle()
	For i As UInteger=0 To 255
		Dim j As UByte=Int(Rnd*255)
		state(i)=i Mod 26
	Next
	For i As UInteger=0 To 255
		Dim j As UByte=Int(Rnd*255)
		Swap state(i),state(j)
	Next
End Sub
Sub n_t.update()
	n=state(n)
End Sub
Sub n_t.prints()
	For i As UInteger=0 To 7
		If (n Shr i) And 1 Then
			Print Chr(219);
		Else
			Print " ";
		EndIf
	Next
	Print
End Sub
Dim shared grid(0 To 800\8,0 To 600\8) As n_t

For x As UInteger=LBound(grid,1)+1 To UBound(grid,1)-1
	For y As UInteger=LBound(grid,2)+1 To UBound(grid,2)-1
		grid(x,y).shufle()
		grid(x,y).n=Int(Rnd*256)
	Next
Next

Sub update_grid(g() As n_t)
	For x As Integer=LBound(g,1)+1 To UBound(g,1)-1
		For y As Integer=LBound(g,2)+1 To UBound(g,2)-1
			g(x,y).n=g(x,y).state((g(x,y-1).n + g(x,y+1).n + g(x-1,y).n + g(x+1,y).n+g(x-1,y-1).n + g(x+1,y+1).n + g(x-1,y+1).n + g(x+1,y-1).n)\8	Mod 256) 
			'g(x,y).n=g(x,y).state(((g(x,y-1).n + g(x,y+1).n + g(x-1,y).n + g(x+1,y).n)	)
		Next
	Next
End Sub
Sub print_grid(g() As n_t)
	Locate 1,1
	For x As Integer=LBound(g,1)+1 To UBound(g,1)-1
		For y As Integer=LBound(g,2)+1 To UBound(g,2)-1
			'Color rgb(g(x,y).n,g(x,y).n,g(x,y).n),0
			'If (g(x,y).n And 1) Then
				'Print Chr(219);
				Print Chr(g(x,y).n+Asc("a"));
			'Else
			'	Print " ";
			'EndIf
		Next
	Next
End Sub
update_grid(grid())
print_grid(grid())
While Not MultiKey(fb.SC_ESCAPE)
update_grid(grid())
print_grid(grid())
If InKey=" " Then
			grid(Rnd*UBound(grid,1),Rnd*UBound(grid,2)).shufle()
EndIf
	Sleep 1000
Wend

Sleep
