#include "sGUI\sGUI.bas"
#include once "sGUI\Window.bas"
#include once "sGUI\SimpleToggle.bas"
using sGUI

screenres 1024,600,32,GFX_ALPHA_PRIMITIVES' 19,32
InitGUI
'customize the GUI
MinimumClearance        =9'fat frame
SelectBrightnessValue   =30'slightly brighter when selected, try a minus sign.
Colors.AlphaValue=224
Colors.Cleaning=&h00000000

Colors.GadBody          =&HFF6600
Colors.GadFrame         =&HFFFF00
Colors.BackGround    		=&H440000
Colors.WinBackGround    =&H770000
Colors.GadBodyGlow      =Colors.GadBody'same colors as above, no glow fx
Colors.GadFrameGlow     =&H00FFFF
Colors.WinFrame         =&H005555
Colors.WinFrameSelected =&H008888
'LoadProportionalFont("Ubuntu\Ubuntu-R\Ubuntu-R.bmp")
'LoadFixedFont("Ubuntu\UbuntuMono-R\UbuntuMono-R.bmp")

dim as sGUIWindow ptr winB
winB=AddWindow(0,350,150,400,400,"winB",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE)
ShowWindow(winB)

dim as Gadget ptr simpleA,toggleA,simpleB,toggleB

simpleA=AddSimpleGadget(0,10,10,70,30,"simpleA")
simpleB=AddSimpleGadget(winB,10,10,70,30,"simpleB")
toggleA=AddToggleGadget(0,100,10,70,30,1,"toggleA")
toggleB=AddToggleGadget(winB,100,10,70,30,1,"toggleB")
GadgetOn(simpleA)
GadgetOn(simpleB)
GadgetOn(toggleA)
GadgetSleep(toggleB)'example SleepMode

dim as integer ff=freefile
open cons for output as ff
do
  sleep 10
  MasterControlProgram
  if GADGETMESSAGE then
    select case GADGETMESSAGE
      case simpleA
        print #ff, "simpleA clicked"
      case simpleB
        print #ff, "simpleB clicked"
      case toggleA
        print #ff, "toggleA " & iif(GetSelect(toggleA)>0,"selected","unselected")
      case toggleB
        print #ff, "toggleB " & iif(GetSelect(toggleB)>0,"selected","unselected")
    end select
  end if
loop until SCREENCLOSEBUTTON
close ff
