#include "sGUI\sGUI.bas"
#include once "sGUI\Window.bas"
#include once "sGUI\SimpleToggle.bas"

using sGUI

screen 19,32
InitGUI

LoadProportionalFont("Ubuntu\Ubuntu-R\Ubuntu-R.bmp")
LoadFixedFont("Ubuntu\UbuntuMono-R\UbuntuMono-R.bmp")

dim as sGUIWindow ptr winA,winB,winC,winD,winE
dim as Gadget ptr buttonA,buttonB,buttonC,buttonD,buttonE
winA=AddWindow(0,10,10,200,200,"winA",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE)
  winC=AddWindow(winA,20,20,150,150,"winC",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_SENDWMSGASPARENT)
    winD=AddWindow(WinC,1,1,50,25,"winD",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_SENDWMSGASPARENT)
    winE=AddWindow(WinC,60,60,50,25,"winE",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_SENDWMSGASPARENT)
winB=AddWindow(0,220,30,200,200,"winB",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE) 
   
ShowWindow(winA)
ShowWindow(winB)
ShowWindow(winC)
ShowWindow(winD)
ShowWindow(winE)

buttonA=AddSimpleGadget(winA,1,1,30,,"A")
buttonB=AddSimpleGadget(winB,1,1,30,,"B")
buttonC=AddSimpleGadget(winC,1,1,30,,"C")
buttonD=AddSimpleGadget(winD,1,1,30,,"D")
buttonE=AddSimpleGadget(winE,1,1,30,,"E")

GadgetOn(buttonA)
GadgetOn(buttonB)
GadgetOn(buttonC)
GadgetOn(buttonD)
GadgetOn(buttonE)

dim as integer ff=freefile
open cons for output as ff
print #ff,"main dialog windows: " & winA,winB 
do
  sleep 10
  MasterControlProgram
  if WINDOWMESSAGE then
    print #ff,WINDOWMESSAGE
  end if
loop until SCREENCLOSEBUTTON
close ff

/'
Dieses Demo zeigt die Funktionsweise des WFLAG_SENDWMSGASPARENT
winD und WinE sind ChildWindows von winC, WinC selbst ist wiedrum ein Childwindow von winA.
In WinD,WinE und WinC ist das WFLAG_SENDWMSGASPARENT gesetzt. Das heißt Ereignisse die in diesen Fenstern stattfinden,
werden als Ereignis des Parentwindows "gemeldet". Auf diese Weise und der verwandschaftlichen Beziehung laufen
alle Fensterereignisse für diesen Fensterzweig in WinA auf. 
'/
