'System Includes
#include once "fbgfx.bi"
#include once "vbcompat.bi"
using FB
namespace sGUI
#include "external\ListObject_Custom_pt1.bi"
#include "external\ListObject.bi"
#include "external\TextObject.bi"
#include "external\sGUI_BitmapFont.bi"
#include "external\ColorDefinition.bi"
#include "sGUI_ColorStorage.bas"'bekomme ich nur dort hin :/
'Fwd Ref
type _WinGadHeader  as WinGadHeader
type _Gadget        as Gadget
type _sGUIWindow    as sGUIWindow
type _EventHandle   as EventHandle
type _Menu          as Menu
type _MenuEntry     as MenuEntry
type _sGUIImage     as sGUIImage
type _BitmapFont    as BitmapFont

'WindowFlags
const as integer WFLAG_WINDOWTYPE0            =&B0000000000000000001'Bit 1  statische Fenster ohne Rahmen
const as integer WFLAG_WINDOWTYPE1            =&B0000000000000000010'Bit 2  statische Fenster mit Rahmen
const as integer WFLAG_WINDOWTYPE2            =&B0000000000000000100'Bit 3  wie WINDOWTYPE1 zustzlich mit breiter Kopfzeile, enthlt(so gegeben) den Fensternamen, "Platz" fr die Windowbuttons
const as integer WFLAG_WINDOWTYPE3            =&B0000000000000001000'Bit 4  Menfenster
const as integer WFLAG_WINDOWTYPE4            =&B0000000000000010000'Bit 5  unbenutzt
const as integer WFLAG_WINDOWTYPE5            =&B0000000000000100000'Bit 6  unbenutzt
const as integer WFLAG_WINDOWTYPE6            =&B0000000000001000000'Bit 7  unbenutzt
const as integer WFLAG_WINDOWTYPE7            =&B0000000000010000000'Bit 8  unbenutzt
const as integer WFLAG_DRAGABLE               =&B0000000000100000000'Bit 9  Fenster ist verschiebbar
const as integer WFLAG_CLOSEABLE              =&B0000000001000000000'Bit 10 Fenster hat nen CloseButton
const as integer WFLAG_MINIMIZABLE            =&B0000000010000000000'Bit 11 unbenutzt, reserviert fr einen MinimalisierButton... mal sehen :)
const as integer WFLAG_STACKABLE              =&B0000000100000000000'Bit 12 Fenster kann sich im Fensterstapel bewegen, hngt natrlich auch von der Art der anderen Fenster ab
const as integer WFLAG_BACKDROP               =&B0000001000000000000'Bit 13 Fenster ist immer im Hintergrund
const as integer WFLAG_ALWAYSONTOP            =&B0000010000000000000'Bit 14 Fenster ist immer oben auf dem Fensterstapel
const as integer WFLAG_WARN                   =&B0000100000000000000'Bit 15 nur dieses Fenster hat Funktionalitt, die anderen Fenster sind gesperrt
const as integer WFLAG_ALWAYSSELECTED         =&B0001000000000000000'Bit 16 Fenster wird permanent selektiert dargestellt
const as integer WFLAG_ALWAYSUNSELECTED       =&B0010000000000000000'Bit 17 Fenster wird permanent unselektiert dargestellt
const as integer WFLAG_DELETEONCLOSE          =&B0100000000000000000'Bit 18 wenn gesetzt wird beim Klicken auf den CloseButton das Fenster(und all dessen Childzeugs) real gelscht, vorhandene Zeiger weisen dann ins Nirwana
const as integer WFLAG_SENDWMSGASPARENT       =&B1000000000000000000'Bit 19 wenn gesetzt dann findet die WINDOWMESSAGE im Parent-Window statt
'Konstanten fr die Beschreibung des Maustastenstatus
const as integer HIT=2      'Taste grad frisch gedrckt
const as integer HOLD=3     'Taste gehalten
const as integer RELEASE=1  'Taste grad losgelassen
const as integer RELEASED=0 'Taste ist losgelassen
'Konstanten Activation
const as integer ACTIVATION_OFF=0
const as integer ACTIVATION_ON=1
const as integer ACTIVATION_SLEEP=2

'Konstanten fr die Beschreibung der Ereignisse von Controls
'LMB
const as integer GADGET_LMBHIT=1         'Control grad frisch gedrckt
const as integer GADGET_LMBHOLD=2        'Control wird gehalten, Maus ber dem Control
const as integer GADGET_LMBHOLDOFF=3     'Control wird gehalten, Maus neben dem Control
const as integer GADGET_LMBRELEASE=4     'Control regulr losgelassen
const as integer GADGET_LMBRELEASEOFF=5  'Control losgelassen, dabei ist Maus neben dem Control
'MMB
const as integer GADGET_MMBHIT=6         'Control grad frisch gedrckt
const as integer GADGET_MMBHOLD=7        'Control wird gehalten, Maus ber dem Control
const as integer GADGET_MMBHOLDOFF=8     'Control wird gehalten, Maus neben dem Control
const as integer GADGET_MMBRELEASE=9     'Control regulr losgelassen
const as integer GADGET_MMBRELEASEOFF=10 'Control losgelassen, dabei ist Maus neben dem Control
'RMB
const as integer GADGET_RMBHIT=11        'Control grad frisch gedrckt
const as integer GADGET_RMBHOLD=12       'Control wird gehalten, Maus ber dem Control
const as integer GADGET_RMBHOLDOFF=13    'Control wird gehalten, Maus neben dem Control
const as integer GADGET_RMBRELEASE=14    'Control regulr losgelassen
const as integer GADGET_RMBRELEASEOFF=15 'Control losgelassen, dabei ist Maus neben dem Control
'Highlighting
const as integer GADGET_MOUSEHOVER=16    'Control ist losgelassen, dabei "schwebt" Maus berm dem Control
const as integer GADGET_MOUSENEXT =17    'Control ist losgelassen, dabei ist Maus jetzt neben dem Control
'Keyboard
const as integer GADGET_KEYBOARD=18    'Control verarbeitet die Tastatureingaben
const as integer GADGET_KEYBOARDOFF=19 'Abbruch der Verarbeitung der Tastatureingaben eines Controls
'Wheel
const as integer GADGET_WHEELMOVE=20  'Rad wurde bewegt
'Konstanten fr die Beschreibung der Ereignisse von Fenstern
'LMB
const as integer WINDOW_LMBHIT=1         '
const as integer WINDOW_LMBHOLD=2        '
const as integer WINDOW_LMBHOLDOFF=3     '
const as integer WINDOW_LMBRELEASE=4     '
const as integer WINDOW_LMBRELEASEOFF=5  '

'Konstanten fr MessageBoxen
'MB Types
const as integer MBType_OK=1
const as integer MBType_YESNO=2
const as integer MBType_CANCELRETRYIGNORE=3
const as integer MBType_OKCANCEL=4
const as integer MBType_RETRYCANCEL=5
const as integer MBType_YESNOCANCEL=6
'MB Button Returnwerte
const as integer MBButton_OK=1
const as integer MBButton_CANCEL=2
const as integer MBButton_RETRY=3
const as integer MBButton_IGNORE=4
const as integer MBButton_YES=5
const as integer MBButton_NO=6
'Men Konstanten
const as string METag_STRIPSTART="STR:"
const as string METag_ITEM="ITM:"
const as string METag_CHECKMARK="CHK:"
const as string METag_SEPARATOR="SEP:"
const as string METag_STRIPEND="END:"

'GFX Zeugs
'GUI interner Abstand
dim shared as integer MinimumClearance
'Farben
dim shared as ColorStorage Colors
dim shared as integer SelectBrightnessValue
'Font
dim shared as integer fontheight
dim shared as _BitmapFont ptr FontA,FontB
dim shared as integer ScrnWidth,ScrnHeight

'System Events
'Keyboard
dim shared as string  KEY
dim shared as integer ASCCODE
dim shared as integer EXTENDED
dim shared as integer SCANCODE

'Maus
dim shared as integer MOUSEMOVED'idea by Petan
dim shared as integer MOUSEX
dim shared as integer MOUSEY
dim shared as integer LMB
dim shared as integer MMB
dim shared as integer RMB
dim shared as integer LMB_DOUBLE_CLICK, MMB_DOUBLE_CLICK, RMB_DOUBLE_CLICK
dim shared as integer WHEEL
dim shared as integer SCREENCLOSEBUTTON

'alte Vergleichswerte, in der Regel vom vorherigen Loopdurchlauf
dim shared as integer oldMOUSEX
dim shared as integer oldMOUSEY
dim shared as integer LMBpressed,MMBpressed,RMBpressed
dim shared as integer oldLMB
dim shared as integer oldMMB
dim shared as integer oldRMB
dim shared as integer oldWHEEL
dim shared as integer wheelvalue,oldwheelvalue
dim shared as integer NEWCLICKSEQUENCE

'Message System
dim shared as _Gadget ptr       GADGETMESSAGE'Nummer(genauer Pointer) des Gadgets, welches nen "Ping" von sich gibt
dim shared as _sGUIWindow ptr   WINDOWMESSAGE'Nummer(genauer Pointer) des Fensters, in welchem eine GADGETMESSAGE auftrat
dim shared as integer           MENUMESSAGE'ID des Meneintrages, welcher angewhlt wurde

'jedes Gadget darf ein(1!) Fenster enthalten, zur Verwaltung diese Liste hier
dim shared as ListObject ptr GadgetWindowList

'Einstiegspunkt frs MCP
dim shared as _sGUIWindow ptr RootWindow

'****Listen
dim shared as ListObject ptr EventHandleList,GadgetLists,WindowLists,ImageList,TOList,MenuList,MenuEntryLists,PointerLists

declare sub ShowWindow    (win as _sGUIWindow ptr)
declare sub HideWindow    (win as _sGUIWindow ptr)
declare sub DeleteWindow  (win as _sGUIWindow ptr)

declare sub GadgetOn    (gad as _Gadget ptr)
declare sub GadgetSleep (gad as _Gadget ptr)
declare sub GadgetOff   (gad as _Gadget ptr)

declare sub RestoreActivation overload (gad as _Gadget ptr)
declare sub ModifyActivation (gad as _Gadget ptr, mode as integer=ACTIVATION_OFF)

declare function GetSelect (gad as _Gadget ptr) as integer
declare sub SetSelect (gad as _Gadget ptr,Selection as integer)

declare sub DrawGadget(gad as _Gadget ptr)
declare sub DrawBranch(win as _sGUIWindow ptr=0) 
declare function GadgetAction(gad as _Gadget ptr, action as integer) as integer
declare sub UpdateGadget(gad as _Gadget ptr)
declare sub SetCaption(gad as _Gadget ptr,Text as string)
declare sub UpdateInternalEventHandle (gad as _Gadget ptr)

declare function UImport(s as string) as string
declare function UExport(s as string) as string

declare sub GetGlobalPosition(entity as any ptr, byref posx as integer, byref posy as integer)

declare function AddImageEntry as _sGUIImage ptr
declare sub DelImageEntry(sguiimg as _sGUIImage ptr)
declare sub DelEventHandle(event as _EventHandle ptr)
declare function AddMenu as _Menu ptr
declare sub DelMenu (m as _Menu ptr)

'sGUI Includes
#include "sGUI_SystemEvents.bas"
#include "Phrases.bi"
#include "sGUI_Font.bas"
#include "sGUI_Drawing.bas"
#include "sGUI_ImageType.bas"
#include "sGUI_WindowGadgetType.bas"
#include "TOGadgetBindings.bas"
#include "sGUI_MenuType.bas"
#include "sGUI_Misc.bas"
#include "sGUI_Init.bas"
#include "external\ListObject_Custom_pt2.bi"
#include "sGUI_MCP.bas"
end namespace

sGUI.SCREENCLOSEBUTTON=0
sGUI.NEWCLICKSEQUENCE=0
sGUI.FontA=new sGUI.BitmapFont
sGUI.FontB=new sGUI.BitmapFont

sGUI.WindowLists=new sGUI.ListObject
sGUI.GadgetLists=new sGUI.ListObject
sGUI.ImageList=new sGUI.ListObject
sGUI.TOList= new sGUI.ListObject
sGUI.MenuList= new sGUI.ListObject
sGUI.MenuEntryLists= new sGUI.ListObject
sGUI.PointerLists= new sGUI.ListObject

'Liste fr Fenster, die Bestandteil eines Gadgets sind
sGUI.GadgetWindowList=sGUI.WindowLists->AppendNew(sGUI.ListObjectType)

'******************************************************************************
'******************************************************************************
'allg. Destruktor**************************************************************

sub Maindestructor destructor 
  if sGUI.FontA then delete sGUI.FontA
  if sGUI.FontB then delete sGUI.FontB   
  if sGUI.WindowLists then delete sGUI.WindowLists
  if sGUI.GadgetLists then delete sGUI.GadgetLists  
  if sGUI.ImageList then delete sGUI.ImageList
  if sGUI.TOList then delete sGUI.TOList
  if sGUI.MenuList then delete sGUI.MenuList
  if sGUI.MenuEntryLists then delete sGUI.MenuEntryLists
  if sGUI.PointerLists then delete sGUI.PointerLists
  if sGUI.RootWindow then delete sGUI.RootWindow 
  'beep' :)<--- it works!!! 
end sub
