#Include Once "./inc/raylib/raygui.bi"
#Include Once "./inc/raylib/raymath.bi"
#Include Once "3dgameraylib.bi"
#Include Once "./arrayList.bi"
#Include Once "math.bi"
#Include Once "iobject.bi"
#define RAYGUI_USER_IMPL
#Ifdef RAYGUI_USER_IMPL
#Include "./inc/raylib/raygui_user_IMPL.bi"
#EndIf

'void DisplayUp() {
'    if(fullscreen) {
'        SetConfigFlags(FLAG_WINDOW_UNDECORATED | FLAG_VSYNC_HINT);
'        InitWindow(GetMonitorWidth(0), GetMonitorHeight(0), APP_TITLE);
'        SetWindowMinSize(GetMonitorWidth(0), GetMonitorHeight(0));
'    } else {
'        SetConfigFlags(FLAG_WINDOW_RESIZABLE | FLAG_VSYNC_HINT);
'        InitWindow(800,450, APP_TITLE);
'        SetWindowMinSize(320,240);
'    }
'}
'
'void DisplayDown() { CloseWindow(); }
' Slider control with pro parameters
' NOTE: Other GuiSlider*() controls use this one
'bool OBBToFrustumIntersect(const OBB &obb, const FrustumVolume &frustum)
'{	// Do a SAT test along each frustum axis.
	'	// A frustum consists of six planes. Note that as near and far planes are parallel, we could optimize
	'	// one iteration away.
	'	for(int i = 0; i < 6; i++)
	'	{
	'	// Find the negative and positive far points of the OBB to the current frustum plane.
	'	float x = Dot(obb.axes[0], frustum.planes.normal) >= 0.f ? obb.halfDistances[0] : -obb.halfDistances[0];
	'	float y = Dot(obb.axes[1], frustum.planes.normal) >= 0.f ? obb.halfDistances[1] : -obb.halfDistances[1];
	'	float z = Dot(obb.axes[2], frustum.planes.normal) >= 0.f ? obb.halfDistances[2] : -obb.halfDistances[2];
	'	// There are eight half-diagonal vectors on an OBB. (A half-diagonal is a vector from OBB center to one of its
	'	// corner vertices). Compute the half-diagonal vector that points most in the same direction than the plane normal.
	'	const float3 diag = x*obb.axes[0] + y*obb.axes[1] + z*obb.axes[2];
	'	// nPoint is now the corner point of the OBB that lies "the most" inside the frustum,
	'	// its projection on the plane normal extends the most to the negative direction of that normal.
	'	const float3 nPoint = obb.center - diag;
	'	//		const float3 pPoint = obb.center + diag;
	'	if (Dot(nPoint, frustum.planes.normal) + frustum.planes.d >= 0.f)
	'		return false; // OBB outside frustum.
	'		// If we would like to check whether the OBB is fully inside the frustum, need to compute
	'		// Dot(pPoint, frustum.planes.normal) + frustum.planes.d. If its < 0 for all planes, OBB is totally
	'		// inside the frustum and doesnt intersect any of the frustum planes.
	'	}
	'	return true;
	'	// OBB inside the frustum or part of the OBB intersects the frustum.
'}
'public Mesh BuildMesh()        {            Mesh mesh = new Mesh();            for (int x = 0; x < ChunkCubes.Length; x++)            {                for (int z = 0; z < ChunkCubes[x].Length; z++)                {                    for (int y = 0; y < ChunkCubes[x][z].Length; y++)                    {                        // Code for check if its a side cube!                        bool xSide = x == ChunkCubes.Length - 1;                        bool zSide = z == ChunkCubes[x].Length - 1;                        bool ySide = y == ChunkCubes[x][z].Length - 1;                        bool nxSide = x == 0;                        bool nzSide = z == 0;                        bool nySide = y == 0;                    }                }            }            return mesh;        }
Sub NormalizePlane(ByRef plane As Rectangle)
	Dim As Single mag = sqrt(plane.x * plane.x + plane.y * plane.y + plane.Width * plane.width)
	plane.x = plane.x / mag
	plane.y = plane.y / mag
	plane.width = plane.width / mag
	plane.height = plane.height / mag
End Sub
Sub ExtractFrustumPlanes(p_planes As Rectangle ptr,comboMatrix As Matrix , normaliz As boolean)

	' Left clipping plane
	p_planes[1].x = comboMatrix.m3 + comboMatrix.m0
	p_planes[1].y = comboMatrix.m7 + comboMatrix.m4
	p_planes[1].width = comboMatrix.m11 + comboMatrix.m8
	p_planes[1].height = comboMatrix.m15 + comboMatrix.m12
	' Right clipping plane
	p_planes[0].x = comboMatrix.m3 - comboMatrix.m0
	p_planes[0].y = comboMatrix.m7 - comboMatrix.m4
	p_planes[0].width = comboMatrix.m11 - comboMatrix.m8
	p_planes[0].height = comboMatrix.m15 - comboMatrix.m12
	' Top clipping plane
	p_planes[3].x = comboMatrix.m3 - comboMatrix.m1
	p_planes[3].y = comboMatrix.m7 - comboMatrix.m5
	p_planes[3].width = comboMatrix.m11 - comboMatrix.m9
	p_planes[3].height = comboMatrix.m15 - comboMatrix.m13
	' Bottom clipping plane
	p_planes[2].x = comboMatrix.m3 + comboMatrix.m1
	p_planes[2].y = comboMatrix.m7 + comboMatrix.m5
	p_planes[2].width = comboMatrix.m11 + comboMatrix.m9
	p_planes[2].height = comboMatrix.m15 + comboMatrix.m13
	' Near clipping plane
	p_planes[5].x = comboMatrix.m3 + comboMatrix.m2
	p_planes[5].y = comboMatrix.m7 + comboMatrix.m6
	p_planes[5].width = comboMatrix.m11 + comboMatrix.m10
	p_planes[5].height = comboMatrix.m15 + comboMatrix.m14
	' Far clipping plane
	p_planes[4].x = comboMatrix.m3 - comboMatrix.m2
	p_planes[4].y = comboMatrix.m7 - comboMatrix.m6
	p_planes[4].width = comboMatrix.m11 - comboMatrix.m10
	p_planes[4].height = comboMatrix.m15 - comboMatrix.m14
	' Normalize the plane equations, if requested
	if (normaliz = TRUE) Then
		NormalizePlane(p_planes[0])
		NormalizePlane(p_planes[1])
		NormalizePlane(p_planes[2])
		NormalizePlane(p_planes[3])
		NormalizePlane(p_planes[4])
		NormalizePlane(p_planes[5])
	endif
End Sub
Function PointInFrustum(planes As Rectangle Ptr, pt As Vector3 ) As boolean

	' If you remember the plane equation (A*x + B*y + C*z + D = 0), then the rest
	' of this code should be quite obvious and easy to figure out yourself.
	' In case don't know the plane equation, it might be a good idea to look
	' at our Plane Collision tutorial at www.GameTutorials.com in OpenGL Tutorials.
	' I will briefly go over it here.  (A,B,C) is the (X,Y,Z) of the normal to the plane.
	' They are the same thing... but just called ABC because you don't want to say:
	' (x*x + y*y + z*z + d = 0).  That would be wrong, so they substitute them.
	' the (x, y, z) in the equation is the point that you are testing.  The D is
	' The distance the plane is from the origin.  The equation ends with "= 0" because
	' that is true when the point (x, y, z) is ON the plane.  When the point is NOT on
	' the plane, it is either a negative number (the point is behind the plane) or a
	' positive number (the point is in front of the plane).  We want to check if the point
	' is in front of the plane, so all we have to do is go through each point and make
	' sure the plane equation goes out to a positive number on each side of the frustum.
	' The result (be it positive or negative) is the distance the point is front the plane.

	' Go through all the sides of the frustum
	For i As Long = 0 To 5
		' Calculate the plane equation and check if the point is behind a side of the frustum
		if(planes[i].x * pt.x + planes[i].y * pt.y + planes[i].width * pt.z + planes[i].height <= 0) Then
			' The point was behind a side, so it ISN'T in the frustum
			return FALSE
		EndIf
	Next

	' The point was inside of the frustum (In front of ALL the sides of the frustum)
	return TRUE
End Function
Function CubeInFrustum(planes As Rectangle Ptr, p As Vector3 ,s As Vector3 ) As boolean
	Dim res As Long=0

	For i As Long = 0 To 5
		'	PointInFrustum(planes

	Next




	return TRUE
End Function

sub Main_Menue(bounds As Rectangle,state As Long Ptr)

	static As Long menue_state
	Static As Long comboBoxActive
	Static As Long comboBoxActiveState

	Static option_state As Long
	Dim options_window_bounds As Rectangle = Rectangle(bounds.width+40,20,GetScreenWidth()-bounds.width-60,GetScreenHeight-40)
	Dim options_window_box_bounds As Rectangle = Rectangle(bounds.x,20,bounds.width,bounds.y-40)
	Dim options_window_sub_bounds As Rectangle
	Static As Long option_comboBoxActive
	Static As Long option_comboBoxActiveState
	Dim button_bounds As Rectangle = Rectangle(bounds.x+bounds.width*0.15,bounds.y+40,bounds.width*0.7,31) 'set the button sizes


	If comboBoxActiveState=0 Then
		comboBoxActiveState=1
		comboBoxActive=-1
		menue_state=-1
	EndIf

	'Print c.r,c.g,c.b,c.a
	Dim As ZString*64 menue_str(0 To 4) = {"","#255##198#Main Menue","#000##005#Load","#000##006#Save","#000##190#Options"}

	If menue_state<>1 Then 'draw menue only if we are not in the beginning mode of the game
		If GuiWindowBox(bounds,menue_str(0)) Then *state=-1 'draw the menue and set the gamestate to exit if cross is clicked
		comboBoxActive = GuiToggleGroup(button_bounds, !"#131#Start\n#005#Load\n#006#Save\n#190#Options\n#159#Exit\0", comboBoxActive)
		If comboBoxActive>-1 Then
			menue_state=comboBoxActive+1
		EndIf
	EndIf





	If menue_state=1 Then 'here we are in the playscreen
		comboBoxActive=-1
		comboBoxActiveState=0
		*state=1 'set the gamestate to beginningmode
	EndIf

	If menue_state=2 Then 'here we are in the loading screen
		GuiWindowBox(options_window_bounds ,menue_str(menue_state))

	EndIf

	If menue_state=3 Then 'here we are in the save screen
		GuiWindowBox(options_window_bounds ,menue_str(menue_state))

	EndIf

	If menue_state=4 Then 'here we are in the optionscreen

		If option_comboBoxActiveState=0 Then
			option_comboBoxActiveState=1
			option_comboBoxActive=-1
			option_state=-1
		EndIf

		If GuiWindowBox(options_window_box_bounds ,menue_str(menue_state)) Then *state=-1 'draw the menue and set the gamestate to exit if cross is clicked
		If GuiWindowBox(options_window_bounds ,menue_str(menue_state)) Then *state=-1 'draw the menue and set the gamestate to exit if cross is clicked
		button_bounds=Rectangle(options_window_box_bounds.x+options_window_box_bounds.width*0.15,options_window_box_bounds.y+40,options_window_box_bounds.width*0.7,31) 'set the button sizes
		option_comboBoxActive = GuiToggleGroup(button_bounds, !"#150#Game\n#181#Graphics\n#122#Audio\n#052#Controls\n#159#Back", option_comboBoxActive)
		If comboBoxActive>-1 Then
			option_state=comboBoxActive+1
		EndIf


		'DrawRectangleRec( options_window_sub_bounds, Fade(GetColor(GuiGetStyle(DEFAULT, BASE_COLOR_NORMAL)),0.25))
		'DrawRectangleLinesEx( options_window_sub_bounds,2, Fade(GetColor(GuiGetStyle(DEFAULT, BORDER_COLOR_NORMAL)),0.25))


		''Dim button_bounds As Rectangle = Rectangle(options_window_bounds.x+50,options_window_bounds.y+40,bounds.width-100,32)
		'Static As long options_scrollbar
		'options_scrollbar = GuiScrollBar(Rectangle(options_window_bounds.width+bounds.width,options_window_sub_bounds.y,20,options_window_sub_bounds.height),options_scrollbar,0,100)
		'DrawRectangleLinesEx( Rectangle(options_window_bounds.width+bounds.width,options_window_sub_bounds.y,20,options_window_sub_bounds.height),2, Fade(GetColor(GuiGetStyle(DEFAULT, BORDER_COLOR_NORMAL)),0.25))

	EndIf


	If menue_state=5 Then 'exit game
		comboBoxActive=-1
		comboBoxActiveState=0
		*state=-1 'set the gamestate to beginningmode
	EndIf



End Sub



Type galaxy extends IObject_t
	model As arrayList 'Vector3
	pre_model As arrayList 'Vector3
	systems As arrayList 'system_t
	oc As OctTree Ptr
	As Texture2D bill
	Declare Constructor(size0 As Long)
	Declare Destructor()
	Declare Sub render(cam As camera3d,frust As rectangle Ptr,debug As boolean)
	Declare Sub pre_render(cam As camera3d,frust As rectangle Ptr,debug As boolean)
	Declare Function rebuild(nrArms As ULong,armOffsetMul As long,innerRadius As long,bulgeOffset0 As long,bulgeOffset1 As long,bulgeSize As long,SizeY As long,SizeXZ As long) As Long
	Declare Function pre_rebuild(nrArms As ULong,armOffsetMul As long,innerRadius As long,bulgeOffset0 As long,bulgeOffset1 As long,bulgeSize As long,SizeY As long,SizeXZ As long) As Long

End Type
Constructor galaxy(size0 As Long)
Dim Parsec As double=3.27 'per sector -> 1,09 LY per system
'stars=New arrayList
If bill.id=0 Then
	bill=LoadTextureFromImage(GenImageGradientRadial(512, 512, 0.25,RayColor(255,255,255,255),RayColor(0,0,0,0)))
EndIf
posi=Vector3(0,0,0)
This.size=Vector3(size0,size0,size0)
'this.size.y=size.y
'this.size.z=size.z
Dim b As Cuboid=Cuboid(vector3(0,0,0),vector3(size0*2,size0*2,size0*2))
oc=New Octtree(b,8)
End Constructor
destructor galaxy()
If systems.count>0 Then
	For i As ULong=0 To systems.count-1
		'Dim s As system_t Ptr=systems.get(i)
		's->delete_stars()
		's=NULL
		systems.removeLast()
	next
EndIf
If pre_model.count>0 Then
	For i As ULong=0 To pre_model.count-1
		'Dim s As system_t Ptr=systems.get(i)
		's->delete_stars()
		's=NULL
		pre_model.removeLast()
	next
EndIf
Delete oc
oc=NULL
This.size=Vector3(0,0,0)
If bill.id<>0 Then UnloadTexture(this.bill)
End Destructor
Sub galaxy.render(cam As camera3d,frust As rectangle Ptr,debug As boolean)
	'real metrics
	'Dim Parsec As doube=3.26 'per sector -> 1,0866666666666666666666666666667 LY per system
	'game metrics
	#Define SOLZ0 3500
	Static t As Single
	Dim d As Long=1000
	t+=GetFrameTime()
	Dim Parsec As double=3.27 'per sector -> 1,09 LY per system
	If debug Then
		drawCubeWires(Vector3(0,0,0),size.x*Parsec,size.y*Parsec,size.z*Parsec,MAROON)
	EndIf
	If systems.count>0 Then
		For i As ULong=0 To systems.count-1
			Dim As system_t Ptr s=systems.get(i)
			'If PointInFrustum(frust,s->posi) Then
			Dim size As Double=0.5*((s->star[0].radius/SOLZ))
			
			Dim c As ULong=Temperature2RGB(s->star[0].temperature)
			If s->nr_stars>1 Then
				d=((s->star[0].temperature/s->star[1].temperature)*1000)
				If t < d Then
					c=Temperature2RGB(s->star[0].temperature)
					size=0.5*((s->star[0].radius/SOLZ))
				Else
					c=Temperature2RGB(s->star[1].temperature)
					size=0.5*((s->star[1].radius/SOLZ))
				EndIf
			EndIf
			If t>d Then t-=d
			Dim colrgb As RayColor
			colrgb.a=(c Shr 24) And 255
			colrgb.r=(c Shr 16) And 255
			colrgb.g=(c Shr 8) And 255
			colrgb.b=(c) And 255
			size=1
			DrawBillboard(cam, bill, s->posi, size, colrgb)
			'EndIf
		Next
	endif
End Sub
Sub galaxy.pre_render(cam As camera3d,frust As rectangle Ptr,debug As boolean)
	'real metrics
	'Dim Parsec As doube=3.26 'per sector -> 1,0866666666666666666666666666667 LY per system
	'game metrics
	#Define SOLZ0 3500
	Static t As Single
	Dim d As Long=1000
	t+=GetFrameTime()
	Dim Parsec As double=3.27 'per sector -> 1,09 LY per system
	If debug Then
		drawCubeWires(Vector3(0,0,0),size.x*Parsec,size.y*Parsec,size.z*Parsec,MAROON)
	EndIf
	If pre_model.count>0 Then
		For i As ULong=0 To pre_model.count-1
			Dim As IObject_t Ptr s=pre_model.get(i)
			'If PointInFrustum(frust,s) Then
			Dim c As RayColor=RayColor(128,0,255,255)
			'DrawBillboard(cam, bill, Vector3(s->posi.x,s->posi.y,s->posi.z), 1, c)
			'EndIf
		Next
	EndIf
	'oc->render(RayColor(16,16,16,16))
End Sub
Function galaxy.rebuild(nrArms As ULong,armOffsetMul As long,innerRadius As long,bulgeOffset0 As long,bulgeOffset1 As long,bulgeSize As long,SizeY As long,SizeXZ As long) As Long
	'Static i As long
	'Static k As long
	'If i>=900 Then
	If oc<>NULL Then
		oc->clean()
	EndIf
	If systems.count>0 Then
		For i As ULong=0 To systems.count-1
			systems.removeLast()
		next
		'i=0
		'k=0
	Else
		'i=0
		'k=0
	EndIf
	'endif

	'Randomize seed
	Dim r As Double
	Dim r_max As Double=(900*900)/(armOffsetMul^2)
	Dim n As Long=900*nrArms
	For i As ULong=0 To 900
		For k As ULong=1 To nrArms*3'SizeXZ-1
			'If k<nrArms Then
			Dim x As double=(Sin((i*(armOffsetMul/10)+k*(360/nrArms))/180*M_PI)*(i*i)/(armOffsetMul^2))
			Dim z As Double=(Cos((i*(armOffsetMul/10)+k*(360/nrArms))/180*M_PI)*(i*i)/(armOffsetMul^2))
			'Print x,z
			r =(Sqr(x*x+z*z)/r_max)
			'If r>SizeXZ Then Continue for
			'If r >255 Then Return res
			Dim bulgex As Double=(smoothStep((Abs(x/r_max)+innerRadius/200),bulgeOffset0/100,bulgeOffset1/100)*0.99+0.01)'*bulgeSize/100
			Dim bulgez As Double=(smoothStep((abs(z/r_max)+innerRadius/200),bulgeOffset0/100,bulgeOffset1/100)*0.99+0.01)'*bulgeSize/100
			Dim bulge As Double=(bulgex*bulgez)*(bulgeSize/64)
			'Dim bulge As Double=1-(smoothStep(Abs(Abs(r/256)-(innerRadius/200)),bulgeOffset0/100,bulgeOffset1/100)*0.9+0.1)*bulgeSize
			Dim s As Double=(0.2+bulge*0.8)*(SizeY)

			Dim As Vector3 posi=Vector3(((x/r_max)*SizeXZ+((-0.5+Rnd)*s)),((-0.5+Rnd)*(s)),((z/r_max)*SizeXZ+((-0.5+Rnd)*s)))
			'Dim As IObject_t o=New IObject_t(posi,Vector3(1,1,1))

			Dim st As system_t Ptr= RL_CALLOC(1,SizeOf(system_t))
			st->generate_system(1+Int(Rnd*1.4),posi)
			systems.add(st)
			'EndIf
		Next
		'	i+=1
		'If i>=900 Then Return 1
		'Return 0
	Next
	'For l As long=0 To 1
	'next
	'next

	'Next
	'Print res.count,r,r_max

	'Return gala
	Return 1
End Function
Function galaxy.pre_rebuild(nrArms As ulong,armOffsetMul As long,innerRadius As long,bulgeOffset0 As long,bulgeOffset1 As long,bulgeSize As long,SizeY As long,SizeXZ As long) As Long
	If pre_model.count>0 Then
		For i As Long=0 To pre_model.count-1
			pre_model.removeLast()
		next
	EndIf
	If oc<>NULL Then
		oc->clean()
	EndIf

	'Randomize seed
	Dim r As Double
	Dim r_max As Double=(900*900)/(armOffsetMul^2)
	Dim n As Long=900*nrArms
	For i As ULong=0 To 900
		For k As ULong=1 To nrArms*3'SizeXZ-1
			'If k<nrArms Then
			Dim x As double=(Sin((i*(armOffsetMul/10)+k*(360/nrArms))/180*M_PI)*(i*i)/(armOffsetMul^2))
			Dim z As Double=(Cos((i*(armOffsetMul/10)+k*(360/nrArms))/180*M_PI)*(i*i)/(armOffsetMul^2))
			'Print x,z
			r =(Sqr(x*x+z*z)/r_max)
			If r>SizeXZ Then Continue for
			'If r >255 Then Return res
			Dim bulgex As Double=(smoothStep((Abs(x/r_max)+innerRadius/200),bulgeOffset0/100,bulgeOffset1/100)*0.99+0.01)'*bulgeSize/100
			Dim bulgez As Double=(smoothStep((abs(z/r_max)+innerRadius/200),bulgeOffset0/100,bulgeOffset1/100)*0.99+0.01)'*bulgeSize/100
			Dim bulge As Double=(bulgex*bulgez)*(bulgeSize/64)
			'Dim bulge As Double=1-(smoothStep(Abs(Abs(r/256)-(innerRadius/200)),bulgeOffset0/100,bulgeOffset1/100)*0.9+0.1)*bulgeSize
			Dim s As Double=(0.2+bulge*0.8)*(SizeY)

			Dim As Vector3 Ptr posi=New Vector3(((x/r_max)*SizeXZ+((-0.5+Rnd)*s)),((-0.5+Rnd)*(s)),((z/r_max)*SizeXZ+((-0.5+Rnd)*s)))
			Dim As IObject_t ptr o=New IObject_t(vector3(posi->x,posi->y,posi->z),Vector3(1,1,1))
			'Dim st As system_t Ptr= RL_CALLOC(1,SizeOf(system_t))
			'st->generate_system(1+Int(Rnd*1.4),posi)
			pre_model.add(o)
			oc->insert(o)
			
			'Delete posi
			'EndIf
		Next
		'	i+=1
		'If i>=900 Then Return 1
		'Return 0
	Next
	'For l As long=0 To 1
	'next
	'next

	'Next
	'Print res.count,r,r_max

	'Return gala
	Return 0
End Function
Sub Generate_Galaxy(bounds As Rectangle,state As Long Ptr,ByRef galax As galaxy Ptr )
	
	'galax =New galaxy(Vector3(1,1,1))
	GuiGroupBox(bounds,"Generate")
	GuiWindowBox(bounds,"Generate")
	Static SizeXZ As Long
	Static SizeY As Long
	Static SizeXZ_old As Long
	Static SizeY_old As Long

	'Static startAngle0 As long
	'Static endAngle0 As long
	'Static startAngle1 As long
	'Static endAngle1 As long
	Static innerRadius As Long
	Static innerRadius_old As Long
	'Static outerRadius As long
	Static bulgeOffset0 As Long
	Static bulgeOffset1 As Long
	Static bulgeSize As Long
	Static bulgeOffset0_old As Long
	Static bulgeOffset1_old As Long
	Static bulgeSize_old As Long
	'Static spread As long
	Static nrArms As Long
	Static nrArms_old As Long
	'Static armSize As long
	'Static armSize_old As long
	Static armoffsetMul As Long
	Static armoffsetMul_old As Long
	static seed As Ulong
	static rebuild_galax As ulong
	Static seed_set As long
	Static txt_in As boolean

	If seed_set=0 Then
		seed=int(Rnd*ULONG_MAX)
		SizeXZ=255
		SizeY=64
		'startAngle1=Int(Rnd*INT_MAX) Mod 360
		'endAngle0=Int(Rnd*INT_MAX) Mod 360
		'startAngle0=Int(Rnd*INT_MAX) Mod 360
		'startAngle1=Int(Rnd*INT_MAX) Mod 360
		'endAngle0=Int(Rnd*INT_MAX) Mod 360
		'endAngle1=Int(Rnd*INT_MAX) Mod 360
		innerRadius=-200+(Int(Rnd*INT_MAX) Mod 200)
		'outerRadius=Int(Rnd*INT_MAX) Mod 100
		bulgeSize=Int(Rnd*INT_MAX) Mod 100
		bulgeOffset0=Int(Rnd*INT_MAX) Mod 100
		bulgeOffset1=Int(Rnd*INT_MAX) Mod 100
		'spread=Int(Rnd*INT_MAX) Mod 100
		nrArms=2+(Int(Rnd*INT_MAX) Mod 7)
		'armSize=Int(Rnd*INT_MAX) Mod 100
		armOffsetMul=16+(Int(Rnd*INT_MAX) Mod 16)

		seed_set=1
		rebuild_galax=1
	EndIf


	If SizeXZ<>SizeXZ_old Then
		SizeXZ_old=SizeXZ
		SizeY=SizeXZ\4
		rebuild_galax=1
	EndIf
	If SizeY<>SizeY_old Then
		SizeY_old=SizeY
		SizeXZ=(SizeY*4)
		rebuild_galax=1
	EndIf

	If innerRadius<>innerRadius_old Then
		innerRadius_old=innerRadius
		rebuild_galax=1
	EndIf
	If bulgeSize<>bulgeSize_old Then
		bulgeSize_old=bulgeSize
		rebuild_galax=1
	EndIf
	If bulgeOffset0<>bulgeOffset0_old Then
		If bulgeOffset0<bulgeOffset1 Then bulgeOffset0=bulgeOffset1+1
		bulgeOffset0_old=bulgeOffset0
		rebuild_galax=1
	EndIf
	If bulgeOffset1<>bulgeOffset1_old Then
		If bulgeOffset1>bulgeOffset0 Then bulgeOffset1=bulgeOffset0-1
		bulgeOffset1_old=bulgeOffset1
		rebuild_galax=1
	EndIf
	If nrArms<>nrArms_old Then
		nrArms_old=nrArms
		rebuild_galax=1
	EndIf
	If armOffsetMul<>armOffsetMul_old Then
		armOffsetMul_old=armOffsetMul
		rebuild_galax=1
	EndIf
	'If armSize<>armSize_old Then
	'	armSize_old=armSize
	'	rebuild_galax=1
	'EndIf

	''' Draw GUI controls
	'''------------------------------------------------------------------------------
	If MyGuiValueBox(Rectangle( bounds.x+20, bounds.y+50, 300, 20 ),"Seed:",@seed,0,LONG_MAX,txt_in) then
		txt_in= Not(txt_in)
		rebuild_galax=1
	EndIf



	SizeXZ = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+80, 300, 20 ), textFormat("Size XZ: %i", SizeXZ), SizeXZ, 1, 256)
	'SizeY = MyGuiProgressBar(Rectangle( bounds.x+20, bounds.y+110, 300, 20 ), textFormat("Size Y: %i", SizeY),SizeY, 1, 31)
	SizeY = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+110, 300, 20 ), textFormat("Size Y: %i", SizeY),SizeY, 1, 64)

	'startAngle0 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+80, 300, 20 ), textFormat("Start Angle: %i", startAngle0), startAngle0, -360, 360)
	'endAngle0 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+110, 300, 20 ), textFormat("End Angle: %i", endAngle0),endAngle0, -360, 360)
	'startAngle1 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+140, 300, 20 ), textFormat("Start Angle: %i",startAngle1),startAngle1, -360, 360)
	'endAngle1 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+170, 300, 20 ), textFormat("End Angle: %i", endAngle1),endAngle1, -360, 360)

	innerRadius = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+200, 300, 20 ), textFormat("Inner Radius: %i", innerRadius),innerRadius,-200, 200)
	'outerRadius = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+230, 300, 20 ), textFormat("Outer Radius: %i", outerRadius),outerRadius, 0, 200)

	bulgeSize = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+260, 300, 20 ), textFormat("Bulge Size: %i",bulgeSize), bulgeSize, 16, 64)
	bulgeOffset0 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+290, 300, 20 ), textFormat("Bulge Offset0: %i", bulgeOffset0),bulgeOffset0, 0, 100)
	bulgeOffset1 = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+320, 300, 20 ), textFormat("Bulge Offset1: %i", bulgeOffset1),bulgeOffset1, 0, 100)

	'spread = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+350, 300, 20 ), textFormat("Star Spreading: %i", spread), spread, 0, 100)
	nrArms = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+380, 300, 20 ), textFormat("Number of Arms: %i", nrArms),nrArms, 2, 9)
	'armSize = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+410, 300, 20 ), textFormat("Arm Size: %i", armSize),armSize, 0, 100)
	armOffsetMul = MyGuiSliderBar(Rectangle( bounds.x+20, bounds.y+440, 300, 20 ), textFormat("Arm Curvature: %i", armOffsetMul), armOffsetMul, 1, 32)

	'''------------------------------------------------------------------------------
	If GuiButton(Rectangle(bounds.x+bounds.width/4,bounds.y+490,bounds.width/2,40),"Randomize") Then
		seed_set=0
	EndIf
	If GuiButton(Rectangle(bounds.x+bounds.width/4,bounds.y+bounds.height-60,bounds.width/2,40),"Start") Then
		*state=-2
	EndIf

	If rebuild_galax=1 Then
		rebuild_galax=galax->pre_rebuild(nrArms,armOffsetMul,innerRadius,bulgeOffset0,bulgeOffset1,BulgeSize,SizeY,SizeXZ)
	EndIf
End Sub