#Ifndef NULL
  #define NULL cptr(any ptr, 0)
#EndIf
#Include once "NoiseSettings.bi"


Type NoiseFactory
	Declare Static Function CreateNoise(NS As NoiseSettings Ptr) As INoise Ptr
	dummy As byte
End Type
Function NoiseFactory.CreateNoise(NS As NoiseSettings Ptr) As INoise Ptr
	Dim res As INoise Ptr = NULL
	Select Case NS->NoiseType
		Case NS->NoiseType_e.Classic
			res = New ClassicNoise()
		Case NS->FilterType_e.Simplex
			res = New SimplexNoise()
		Case NS->FilterType_e.OpenSimplex
			res = New OpenSimplexNoise()
	End Select
	Return res
End Function