#Include Once "NoiseSettings.bi"
#Include Once "NoiseFilter.bi"

#ifndef NULL
  #define NULL cptr(any ptr, 0)
#EndIf


Type NoiseFilterFactory
	Declare Static Function CreateNoiseFilter(NS As NoiseSettings Ptr) As INoiseFilter Ptr
	dummy As byte
End Type
Function NoiseFilterFactory.CreateNoiseFilter(NS As NoiseSettings Ptr) As INoiseFilter Ptr
	Dim res As INoiseFilter Ptr = NULL
	Select Case NS->FilterType
		Case NS->FilterType_e.Normal
			res = New NormalNoiseFilter(NS)
		Case NS->FilterType_e.Rigid
			res = New RigidNoiseFilter(NS)
	End Select
	Return res
End Function
