'#Include Once "noisefilter.bi"

Type NoiseSettings
	Declare Constructor()
	Declare Destructor()
	Enum FilterType_e
	Normal=1,
	Rigid
	End Enum
	Enum NoiseType_e
	Classic=1,
	Simplex,
	OpenSimplex
	End Enum
	
	NoiseType As NoiseType_e = NoiseType_e.Simplex
	FilterType As FilterType_e =FilterType_e.Rigid
	
	active As boolean
	hide As boolean
	NoiseMask As Integer


	Dim CenterX As Double = 0.0
	Dim CenterY As Double = 0.0
	Dim CenterZ As Double = 0.0
	Dim CenterW As Double = 0.0
	seed As Double=10.0
	minValue As Double = -1.0
	mask_enable As boolean=0
	minMaskValue As Double = -1.0
	negateValue As integer = FALSE
	octaves As Integer = 1
	Dim persistence As Double =0.254*2
	Dim baseRoughness As Double = 0.254*4
	Dim roughness As Double = 0.254*8
	Dim strength As Double = 0.254*4
	Dim addvalue As Double =0.0'-0.5
	Dim weightMult As Double =0.8'-0.5
	'Dim planetsize As Double =2.8'-0.5
	'Dim stepper As Double = 0.1
	
	n_min As Double
	n_max As Double
End Type
Constructor NoiseSettings()
	If octaves<=1 Then octaves=1
		NoiseType = NoiseType_e.Classic
	FilterType = FilterType_e.Normal
	
	active=TRUE
	hide=FALSE
	NoiseMask=-1'0


	'CenterX = 1-Rnd*2
	'CenterY = 1-Rnd*2
	'CenterZ = 0'1-Rnd*2
	'CenterW  = 0.0
	'minValue = (-1.0+Rnd*2)'*0.2
	'minMaskValue = (-1.0+Rnd*2)'*0.2
	'octaves = 1+Rnd*8
	'persistence =0.254*(Rnd*4)
	'baseRoughness = 2+0.254*(Rnd*2)
	'roughness = 2+0.254*(Rnd*2)
	'strength = 0.254*(Rnd*16)
	'addvalue =0.0'-0.5
	'weightMult =-1.0+Rnd*2'-0.5
	'Dim stepper As Double = 0.1
	

End Constructor
destructor NoiseSettings()
End Destructor