#Include Once "crt/stdint.bi"
#Include Once "crt/limits.bi"
Type XorShift_t
	Declare Function xorshift32() As uint32_t
	'Declare Function xorshift64(seed As uint64_t=0,set_seed As boolean=TRUE) As uint64_t
	Declare Function xorshift128() As uint32_t
	Declare Sub setSeed(seed As uint32_t Ptr,modul As Integer)
	seed(0 To 16) As uint32_t

End Type
Sub XorShift_t.setSeed(seed As uint32_t Ptr,modul As Integer)
	If seed<>NULL Then
		Select Case modul
			Case 0
				If seed[0]=0 Then
					this.seed(0)=314159265
				Else
					this.seed(0)=seed[0]
				EndIf
			Case 1
			Case 2
			Case 3
			Case Else

		End Select
	EndIf
End Sub
Function XorShift_t.xorshift32() As uint32_t
	Static As uint32_t x32


	seed(0) Xor= seed(0) Shl 13
	seed(0) Xor= seed(0) Shr 17
	seed(0) xor= seed(0) shl 5
	return seed(0)
End Function

'Function XorShift_t.xorshift64(seed As uint64_t=0,set_seed As boolean=TRUE) As uint64_t
'	Static As uint32_t x64
'	If set_seed=TRUE Then
'		If seed<>0 Then
'			x64=seed
'		Else
'			x64 = Type<uint64_t>(88172645463325252)'ull
'		EndIf
'		set_seed=FALSE
'	EndIf
'	x64 Xor= x64 shl 13
'	x64 Xor= x64 Shr 7
'	x64 Xor= x64 shl 17
'	return x64
'End Function

Type XorShift128_t
	As int32_t x,y,z,w
	Declare Sub SetSeedu(x0 As uint32_t,y0 As uint32_t,z0 As uint32_t,w0 As uint32_t)
	Declare Sub SetSeedi(x0 As int32_t,y0 As int32_t,z0 As int32_t,w0 As int32_t)
	Declare function Randu() As uint32_t
	Declare function Randi() As int32_t
	Declare function Randf() As single
End Type
Sub XorShift128_t.SetSeedu(x0 As uint32_t,y0 As uint32_t,z0 As uint32_t,w0 As uint32_t)
	x=x0:y=0:z=z0:w=w0
End Sub
Sub XorShift128_t.SetSeedi(x0 As int32_t,y0 As int32_t,z0 As int32_t,w0 As int32_t)
	x=x0:y=0:z=z0:w=w0
End Sub
Function XorShift128_t.Randu() As uint32_t
	Dim As uint32_t t = x xor (x Shl 11)
	x = y
	y = z
	z = w
	w xor= (w shr 19) xor t xor (t shr 8)
	return w
End Function
Function XorShift128_t.Randi() As int32_t
	Dim As int32_t t = x xor (x Shl 11)
	x = y
	y = z
	z = w
	w xor= (w shr 19) xor t xor (t shr 8)
	return Type<int32_t>(w)
End Function
Function XorShift128_t.Randf() As single
	Dim As uint32_t t = x xor (x Shl 11)
	x = y
	y = z
	z = w
	w xor= (w shr 19) xor t xor (t shr 8)
	return w/UINT_MAX
End Function
