#Include "crt/limits.bi"
#Include "priorityqueue.bi"
Type node_t
	Declare Constructor()
	Declare Constructor(i As vec4 ptr)
	Declare Destructor()
	id As vec4 ptr
	g As Single
	h As Single
	f As Single
	p As Single
	isinopen As Integer
	isinclosed As Integer
	neightboors As arrayList
	came_from As vec4
End Type
Constructor node_t()

End Constructor
Constructor node_t(i As vec4 ptr)
id=i
isinopen=0
isinclosed =0

End Constructor
Destructor node_t()
If neightboors.count>0 Then
	For i As UInteger=0 To neightboors.count-1
		neightboors.removeLast()
	Next
EndIf
End destructor

Declare Function find_node(n As arrayList Ptr, p As vec4 ptr) As integer

Sub build_nodes(g As object3d ptr, start As uinteger,target As UInteger)
	If nodes.count>0 Then
		For i As UInteger=0 To nodes.count-1
			nodes.removeLast()
		Next
	EndIf
	Dim as edge ptr e0 '= g->edges->get( 0 )
	Dim as edge ptr e1 '= g->edges->get( 0 )
	Dim v0 As vec4
	Dim v1 As vec4

	Dim ni As Integer
	Dim na As Integer
	Dim no As Integer

	Dim As vec4 Ptr start_vec=g->vertices->Get(start)
	Dim As vec4 Ptr current_vec
	Dim As vec4 Ptr end_vec=g->vertices->Get(target)
	Dim n1 As node_t Ptr
	Dim n2 As node_t Ptr
	Dim n0 As node_t Ptr


	For i As Integer=0 To g->vertices->count - 1'g->vertices->count-1
		n1=New node_t(g->vertices->Get(i))
		current_vec=g->vertices->Get(i)
		n1->g=distance3d(current_vec->x,current_vec->y,current_vec->z,start_vec->x,start_vec->y,start_vec->z)
		n1->h=distance3d(current_vec->x,current_vec->y,current_vec->z,end_vec->x,end_vec->y,end_vec->z)
		n1->p=0
		n1->f=n1->g+n1->h+n1->p
		'n->connections=arrayList()
		'		Print n->f,n->g,n->h
		For j as integer = 0 to g->edges->count - 1
			e0 = g->edges->Get( j )

			If e0->vertex1=current_vec  Then
				n2=New node_t(e0->vertex2)
				n2->g=distance3d(e0->vertex2->x,e0->vertex2->y,e0->vertex2->z,start_vec->x,start_vec->y,start_vec->z)
				n2->h=distance3d(e0->vertex2->x,e0->vertex2->y,e0->vertex2->z,end_vec->x,end_vec->y,end_vec->z)
				n2->p=0
				n2->f=n2->g+n2->h+n2->p

				'v0=vec4(*e0->vertex2)
				n1->neightboors.Add(n2)
				n1->came_from=*e0->vertex2
				'Continue for
			EndIf
			If e0->vertex2=current_vec   Then
				n2=New node_t(e0->vertex1)
				n2->g=distance3d(e0->vertex1->x,e0->vertex1->y,e0->vertex1->z,start_vec->x,start_vec->y,start_vec->z)
				n2->h=distance3d(e0->vertex1->x,e0->vertex1->y,e0->vertex1->z,end_vec->x,end_vec->y,end_vec->z)
				n2->p=0
				n2->f=n2->g+n2->h+n2->p
				'v0=vec4(*e0->vertex1)
				n1->neightboors.Add(n2)
				n1->came_from=*e0->vertex1
				'Continue for
			EndIf

			'	n1->connections.Add(v0)
		Next
		'If n1->neightboors.count=0 Then
		Print n1->neightboors.count
		'endif
		'Sleep 160
		nodes.add(n1)
	Next


	'	z+=1
	'Wend
	'open_nodes->Add(n)
	'Next
	'sleep
End Sub

Function get_route(g As object3d ptr, start As uinteger,target As UInteger) As arrayList
	build_nodes(g,start,target)
	Dim as edge ptr e '= g->edges->get( 0 )
	Dim v As vec4 Ptr

	Dim As vec4 Ptr start_vec=g->vertices->Get(start)
	Dim As vec4 Ptr current_vec
	Dim As vec4 Ptr end_vec=g->vertices->Get(target)

	Dim n2 As node_t Ptr
	Dim n As node_t ptr
	Dim open_nodes As FbFrameWork.Collections.Queue=FbFrameWork.Collections.Queue(FbFramework.Collections.Queue.PriorityOrder.Descending )
	Dim close_nodes As FbFrameWork.Collections.Queue=FbFrameWork.Collections.Queue(FbFramework.Collections.Queue.PriorityOrder.Ascending ) ' = arrayList()
	Dim came_nodes As arrayList ' = arrayList()
	'build the nodes tree
	'get the path
	'Print "here"
	Dim v2 As vec4 Ptr
	n=nodes.Get(start)
	n->f=(distance3d(n->id->x,n->id->y,n->id->z,end_vec->x,end_vec->y,end_vec->z))
	open_nodes.push(n->f,n)
	Dim current_node As node_t Ptr=n
	came_nodes.add(n)
	Dim neighbor_node As node_t Ptr
	Dim tmp_node As node_t Ptr
	Dim count As UInteger=0
	Dim As single tentative_gScore
	while current_node->id<>end_vec
		'current_node->isinopen=1
		'current_node->isinclosed=0
		Print "here",open_nodes.count,close_nodes.count,came_nodes.count
		'sleep
		If (current_node->id=end_vec)  Or (open_nodes.count=0) Then
			Exit While
		Else
			'open_nodes.pop()
			close_nodes.push(current_node->f,current_node)
			'If current_node->neightboors.count>0 Then
			For i As Integer=0 To current_node->neightboors.count-1
				neighbor_node=current_node->neightboors.get(i)
				If (neighbor_node->g<current_node->g) And (neighbor_node->isinclosed=1) Then
					tmp_node=neighbor_node
					came_nodes.add(tmp_node)
				ElseIf (current_node->g<neighbor_node->g) And (neighbor_node->isinopen=1) Then
					tmp_node=current_node
					came_nodes.add(tmp_node)
				ElseIf (neighbor_node->isinopen=0) And (neighbor_node->isinclosed=0) Then
					current_vec=neighbor_node->id
					neighbor_node->g=distance3d(current_vec->x,current_vec->y,current_vec->z,start_vec->x,start_vec->y,start_vec->z)
					neighbor_node->h=distance3d(current_vec->x,current_vec->y,current_vec->z,end_vec->x,end_vec->y,end_vec->z)
					neighbor_node->p=0
					neighbor_node->f=current_node->f+neighbor_node->g+neighbor_node->h+neighbor_node->p
					neighbor_node->isinopen=1
					neighbor_node->isinclosed=0
					open_nodes.push(neighbor_node->f,neighbor_node)
				EndIf
			Next
			'EndIf
		EndIf
		current_node=open_nodes.pop()
		current_node->isinopen=0
		current_node->isinclosed=1

	Wend
	For i As UInteger=0 To close_nodes.count-1
		n=close_nodes.pop()
		came_nodes.add(n)
		Print n->f
	Next
	'Sleep
	'make an openlist containing only the starting node
	'make an empty closed list
	'while (the destination node has not been reached):
	'    consider the node with the lowest f score in the open list
	'    if (this node is our destination node) :
	'        we are finished
	'    if not:
	'        put the current node in the closed list and look at all of its neighbors
	'        for (each neighbor of the current node):
	'            if (neighbor has lower g value than current and is in the closed list) :
	'                replace the neighbor with the new, lower, g value
	'                current node is now the neighbor's parent
	'            else if (current g value is lower and this neighbor is in the open list ) :
	'                replace the neighbor with the new, lower, g value
	'                change the neighbor's parent to our current node

	'            else if this neighbor is not in both lists:
	'                add it to the open list and set its g



	Return came_nodes
End Function

Function find_node(n As arrayList Ptr, p As vec4 ptr) As Integer
	If n->count>0 Then
		Dim node As node_t Ptr
		For i As Integer=0 To n->count-1
			node=n->Get(i)
			If node->id=p Then Return i
		Next
	EndIf
	Return -1
End Function
