#Include "fbgfx.bi"

ScreenRes 800,600,32
Randomize timer
Dim x_size As Long=32
Dim y_size As Long=32
Dim view_x As Long=1
Dim view_y As long=10
Dim view_sx As Long=7
Dim view_sy As Long=7
Dim As Long map(x_size-1,y_size-1)
For x0 As Long=0 To x_size-1
	For y0 As Long=0 To y_size-1
		map(x0,y0)=Int(33+Rnd*36)
	Next
Next

Function get_tile_2d(arr() As Long,x As Long,y As long) As Long
	If (x<LBound(arr,1)) Orelse (x>uBound(arr,1)) Orelse (y<LBound(arr,2)) Orelse (y>uBound(arr,2)) Then Return 0
	Return arr(x,y)
End Function
sub render_view_2d(arr() As Long, vx As Long,vy As Long,x As Long,y As Long,xs As Long,ys As Long,tile_size As Long=8,r As boolean=FALSE)
Dim c As Long=&hffffffff
For x0 As Long=0 To xs-1
	For y0 As Long=0 To ys-1
		If r Then c=(Rnd*&hffffffff)
		Draw String(vx+x0*tile_size,vy+y0*tile_size),chr(get_tile_2d(arr(),x0+x,y0+y)),c
	Next
Next
		
End sub

'TODO: draw player centered on both maps

While Not MultiKey(fb.SC_ESCAPE)
	Line(0,0)-(800,600),0,BF
	If MultiKey(fb.SC_A) And view_x>(LBound(map,1)-view_sx+1) Then view_x-=1
	If MultiKey(fb.SC_D) And view_x<UBound(map,1) Then view_x+=1
	If MultiKey(fb.SC_W) And view_y>(LBound(map,2)-view_sy+1) Then view_y-=1
	If MultiKey(fb.SC_S) And view_y<UBound(map,2) Then view_y+=1
	ScreenLock
		Draw String(400,100-16),"overworld map",&hffffffff
			render_view_2d(map(),400,100,0,0,32,32,8)
	Line(400+view_x*8,100+view_y*8)-(400+view_x*8+8,100+view_y*8+8),&h3200ff00,BF
		Draw String(32,32-16),"players view",&hffffffff
	render_view_2d(map(),32,32,view_x,view_y,view_sx,view_sy,16,TRUE )
	Line(32,32)-(32+8,32+8),&h3200ff00,BF
	ScreenUnLock
	screensync
	'Sleep 16
Wend
Sleep