#include "sGUI\sGUI.bas"
#include once "sGUI\Window.bas"

using sGUI

screen 19,32
InitGUI
 Colors.AlphaValue=224
Colors.Cleaning=&h00000000

LoadProportionalFont("Ubuntu\Ubuntu-R\Ubuntu-R.bmp")
LoadFixedFont("Ubuntu\UbuntuMono-R\UbuntuMono-R.bmp")

dim as sGUIWindow ptr backA,backB,backC,stackA,stackB,stackC,topA,topB,topC
stackA=AddWindow(0,100,100,200,100,"Stackable A",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_STACKABLE)
stackB=AddWindow(0,130,130,200,100,"Stackable B",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_STACKABLE)
stackC=AddWindow(0,160,160,200,100,"Stackable C",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_STACKABLE)

backA=AddWindow(0,70,70,200,100,"Backdrop A",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_BACKDROP)'Replace WFLAG_BACKDROP with WFLAG_WARN and see what happens.
backB=AddWindow(0,40,40,200,100,"Backdrop B",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_BACKDROP)
backC=AddWindow(0,10,10,200,100,"Backdrop C",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_BACKDROP)

topA=AddWindow(0,190,190,200,100,"AlwaysOnTop A",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_ALWAYSONTOP)
topB=AddWindow(0,220,220,200,100,"AlwaysOnTop B",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_ALWAYSONTOP)
topC=AddWindow(0,250,250,200,100,"AlwaysOnTop C",WFLAG_WINDOWTYPE2 or WFLAG_DRAGABLE or WFLAG_AlWAYSONTOP)

ShowWindow(backA)
ShowWindow(backB)
ShowWindow(backC)
ShowWindow(stackA)
ShowWindow(stackB)
ShowWindow(stackC)
ShowWindow(topA)
ShowWindow(topB)
ShowWindow(topC)

dim as integer ff=freefile
open cons for output as ff
do
  sleep 10
  MasterControlProgram
loop until SCREENCLOSEBUTTON
close ff

/'
Dieses Demo zeigt das Stackverhalten bei Verwendung der Flags WFLAG_BACKDROP / WFLAG_STACKABLE / WFLAG_ALWAYSONTOP / WFLAG_WARN

WFLAG_BACKDROP:
Fenster mit diesem Flag werden im Stack immer hinten gehalten. Gibt es mehrere Fenster mit diesem Flag so
gilt: Wer zuletzt kommt ist auch ganz hinten!

WFLAG_STACKABLE:
Fenster mit diesem Flag werden nach von geholt, sobald sie angeklickt werden (soweit es andere Fenster zulassen).

WFLAG_ALWAYSONTOP:
Fenster mit diesem Flag sind immer oben auf dem Stapel. Gibt es mehrere Fenster mit diesem Flag so
gilt: Wer zuletzt kommt ist auch ganz oben!

WFLAG_WARN:
Dieses Fenster ist vorn. Der Rest der Gui ist gesperrt.

Voreingestellt sind alle Fenster auf WFLAG_STACKABLE!
'/
