namespace sGUI

declare function AddDragBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0) as Gadget ptr
declare function DragBarActions(gad as Gadget ptr,action as integer) as integer
declare sub DrawDragBar (gad as Gadget ptr)

'Ctrl(0) wenn 1 dann Toggle sonst Simple
'ctrl(13) mouse-over-control-flag
function AddDragBar(win as sGUIWindow ptr,PosX as integer,PosY as integer,GadWidth as integer=0,GadHeight as integer=0) as Gadget ptr
  function=0  
  dim as Gadget ptr gad
  if win=0 then win=RootWindow
  gad=win->GadgetList->AppendNew (GadgetType)
  if gad then
    gad->parent=win
    gad->Selection=0
    gad->Activation=0
    gad->PosX=PosX
    gad->PosY=PosY
    gad->GadHeight=GetFontHeight+2*MinimumClearance
    gad->GadWidth=GadWidth
    
    gad->DrawBuffer->img=imagecreate(gad->GadWidth,Gad->GadHeight,0,32)

    gad->DoDraw     =@DrawDragBar
    gad->DoAction   =@DragBarActions
    gad->DoUpdate   =@DrawDragBar

    function=gad
  end if
end function


function DragBarActions(gad as Gadget ptr,action as integer) as integer
  function=0
  dim as sGUIWindow ptr win,parentwin
  win=cast(sGUIWindow ptr, gad->parent)
  parentwin=cast(sGUIWindow ptr, win->parent)
  select case action     
    case GADGET_LMBHIT
      gad->Ctrl(0)=MOUSEX - win->PosX
      gad->Ctrl(1)=MOUSEY - win->PosY
      'function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!   
    case GADGET_LMBHOLD,GADGET_LMBHOLDOFF
      win->PosX =MOUSEX - gad->Ctrl(0)
      win->PosY =MOUSEY - gad->Ctrl(1)
      if win->PosX<0 then win->PosX=0
      if win->PosY<0 then win->PosY=0     
      if win->PosX > parentwin->ContentWidth - win->WinWidth then win->PosX = parentwin->ContentWidth - win->WinWidth
      if win->PosY > parentwin->ContentHeight - win->WinHeight then win->PosY = parentwin->ContentHeight - win->WinHeight
      'function=1           'Ping!!!! Control meldet sich: bei mir ist was passiert!!!   
  end select  
end function


sub DrawDragBar (gad as Gadget ptr)
  'no gfx ;)
End sub

end namespace
